package de.hdm_stuttgart.mi.sd1;

/**
 * Beginner's way of implementing the »More fun with X-mas trees« exercise.
 */
public class Xmas {

    public static void main(String[] args) {

        // Example: 5 row groups, tree body's loop index ranging from 0 to 4

        //                         \ /           Part 1: Printing tree's top.
        //                       -->*<--
        //                         /_\
        // Row group index 0      /_\_\          Part 2: Tree's body, printing
        //                       /_/_/_\         two lines per group index
        // Row group index 1     /_\_\_\         loop iteration.
        //                      /_/_/_/_\
        // Row group index 2    /_\_\_\_\
        //                     /_/_/_/_/_\
        // Row group index 3   /_\_\_\_\_\
        //                    /_/_/_/_/_/_\
        // Row group index 4  /_\_\_\_\_\_\      End of tree's body
        //                   /_/_/_/_/_/_/_\
        //                        [___]          Part 3: Bottom trunk line.

        final int numberOfRowGroups = 5;                   // You may easily change this
        // parameter.
        // Printing tree's top
        //

        // Tree's top first line
        for (int x = 0; x < numberOfRowGroups + 1; x++) {  // Printing the tree's "\ /"
            // top. We need numberOfRows+1
            System.out.print(' ');                         // preceding spaces before
        }                                                  // eventually printing the
        System.out.println("\\ /");                        // "\ /" String.

        // Tree's top second line
        for (int x = 0; x < numberOfRowGroups - 1; x++) {  // Printing the tree's top '-->*<--'
            // We need numberOfRows-1
            System.out.print(' ');                         // preceding spaces
        }                                                  // before printing the
        System.out.println("-->*<--");                     // "-->*<--" string.

        // Tree's top third line
        for (int x = 0; x < numberOfRowGroups + 1; x++) { // The tree's lower top "/ \" line.
            System.out.print(' ');                        // Again we need numberOfRowGroups+1
        }                                                 // preceding spaces.
        System.out.println("/_\\");

        // Part two: The tree's body
        //
        for (int rowGroup = 0;                            // Outer loop printing the
             rowGroup < numberOfRowGroups; rowGroup++) {  //  tree's body.

            // First body line of current group
            //
            for (int x = 0;                               // Starting first line
                 x < numberOfRowGroups - rowGroup;x++) {  // of row group with
                // (numberOfRows - row)
                System.out.print(' ');                    // space characters ...
            }
            System.out.print("/");                        // Start of current row group's
            for (int x = 0; x < rowGroup + 2;x++) {       // first line tree body content
                System.out.print("_\\");                  // finishing.
            }
            System.out.println();

            // Second body line of current group
            //
            for (int x = 0;                                   // Starting second line of row
                 x < numberOfRowGroups - rowGroup - 1; x++) { // group with (numberOfRows -
                System.out.print(' ');                        // row - 1) space characters ...
            }
            for (int x = 0; x < rowGroup + 3;x++) {           // tree body content
                System.out.print("/_");
            }
            System.out.println("\\");                         // finishing.
        }

        // Part three: The tree's bottom trunk
        //
        for (int x = 0; x < numberOfRowGroups; x++) {         // Indenting the bottom trunk ...
            System.out.print(' ');
        }
        System.out.println("[___]");                          // printing the trunk.
    }

}
