package de.hdm_stuttgart.mi.sd1;


/**
 * Simplified implementation replacing loops by {@link java.io.PrintStream#format(String, Object...)} and
 * {@link String#repeat(int)}.
 */
public class XmasUsingFormat {

    public static void main(String[] args) {

        // Example: 5 row groups, tree body's loop index ranging from 0 to 4

        //                         \ /           Part 1: Printing tree's top.
        //                       -->*<--
        //                         /_\
        // Row group index 0      /_\_\          Part 2: Tree's body, printing
        //                       /_/_/_\         two lines per group index
        // Row group index 1     /_\_\_\         loop iteration.
        //                      /_/_/_/_\
        // Row group index 2    /_\_\_\_\
        //                     /_/_/_/_/_\
        // Row group index 3   /_\_\_\_\_\
        //                    /_/_/_/_/_/_\
        // Row group index 4  /_\_\_\_\_\_\      End of tree's body
        //                   /_/_/_/_/_/_/_\
        //                        [___]          Part 3: Bottom trunk line.

        final int numberOfRowGroups = 5;                   // You may easily change this parameter.

        // Printing the tree's top
        System.out.format("%"+ (numberOfRowGroups + 5) + "s\n",     "\\ /");
        System.out.format("%"+ (numberOfRowGroups + 7) + "s\n",    "-->*<--");
        System.out.format("%"+ (numberOfRowGroups + 5) + "s\n",      "/_\\");

        // Printing the tree's body

        // Loop printing the tree's body row group wise.
        for (int rowGroup = 0; rowGroup < numberOfRowGroups; rowGroup++) {

            // First body line of current group
            System.out.format("%"+ (numberOfRowGroups + rowGroup + 6) + "s\n", "/" + "_\\".repeat(rowGroup + 2));

            // Second body line of current group
            System.out.format
                    ("%"+ (numberOfRowGroups + rowGroup + 6) + "s\\\n",
                     "/_".repeat(rowGroup + 3));
        }
        // Printing the tree's trunk
        System.out.format("%"+ (numberOfRowGroups + 6) + "s\n", "[___]");
    }
}
