package de.hdm_stuttgart.mi.sda1;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jdom2.Element;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class Examination2Rdbms implements AutoCloseable {

  static private final Logger log = LogManager.getLogger(Examination2Rdbms.class);

  private Connection conn;

  private Element examinations;

  public Examination2Rdbms() {
    try {
      conn = DriverManager.getConnection(
          "jdbc:postgresql://localhost/hdm", "hdmuser", "XYZ");
    } catch (final SQLException e) {
      log.error("Unable to establish connection, exiting", e);
      System.exit(1);
    }

    final SAXBuilder builder = new SAXBuilder();
    try {
      examinations = builder.build(new File("Schema/sampledata.xml")).getRootElement();
    } catch (final JDOMException e) {
      log.error("Unable to parse input, exiting", e);
      System.exit(1);
    } catch (final IOException e) {
      log.error("Unable to read input, exiting", e);
      System.exit(1);
    }
  }

  public void execute() {
    log.info("Parsing XML input file");
    log.info("This is your XML document's root elemet at your fingertips:" + examinations);
    log.info("This is a database connection at your fingertips:" + conn);
  }

  @Override
  public void close() {
    try {
      conn.close();
    } catch (final SQLException e) {
      e.printStackTrace();
    }
  }
}
